# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

(n, m, d) = map(int, fi.readline().strip().split())
if 1 > n or n > 500000:
	sys.exit('N out of range')
if 1 > m or m > n:
	sys.exit('M out of range')
if 1 > d or d > m:
	sys.exit('D out of range')
fo.write('{0} {1} {2}\n'.format(n, m, d))

s = 0
for i in range(n):
	a = map(int, fi.readline().strip().split())
	if 0 > a[0] or a[0] > m:
		sys.exit('K[{0}] out of range'.format(1 + i))
	if len(a) != a[0] + 1:
		sys.exit('Invalid format on line {0}'.format(2 + i))
	for j in range(a[0] - 1):
		if 1 > a[1 + j] or a[1 + j] > 1000000000:
			sys.exit('X[{0}, {1}] out of range'.format(1 + i, 1 + j))
	fo.write('{0}\n'.format(' '.join(map(str, a))))
	s += a[0]
if s != m:
	sys.exit('Invalid sum of K[i]')

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 100 and d == 1:
		print('subtask 1')
	elif n <= 100:
		print('subtask 2')
	elif n <= 1000:
		print('subtask 3')
	elif n <= 100000:
		print('subtask 4')
	else:
		print('subtask 5')
