#include <fstream>
#include <vector>
using namespace std;

ifstream sis("gcdsis.txt");
ofstream val("gcdval.txt");

int gcd(int a, int b) {
	while (a > 0) {
		int t = b % a;
		b = a;
		a = t;
	}
	return b;
}

int n, m, d;
vector<int> a;
vector<long long> b;

int main() {
	sis >> n >> m >> d;
	for (int i = 0; i < n; ++i) {
		int k;
		sis >> k;
		for (int j = 0; j < k; ++j) {
			int x;
			sis >> x;
			a.push_back(x);
		}
	}
	b.resize(1 + m);
	b[0] = 0;
	for (int i = 1; i <= m; ++i) {
		b[i] = -1;
		int k = 0;
		for (int j = 1; j <= i; ++j) {
			k = gcd(k, a[i - j]);
			if (j >= d && b[i - j] >= 0 && b[i] < b[i - j] + k) {
				b[i] = b[i - j] + k;
			}
		}
	}
	val << b[m] << '\n';
	return 0;
}
