# sisendi korrektsuse kontrollija

import sys

fi = open(sys.argv[1], 'rt')
fo = open(sys.argv[2], 'wt')

n = int(fi.readline().strip())
if 1 > n or n > 500000:
	sys.exit('N out of range')
fo.write('{0}\n'.format(n))

a = map(int, fi.readline().strip().split())
if len(a) != n:
	sys.exit('Invalid format on line 2')
for i in range(n):
	if 1 > a[i] or a[i] > n:
		sys.exit('A[{0}] out of range'.format(1 + i))
fo.write('{0}\n'.format(' '.join(map(str, a))))

fi.close()
fo.close()

if len(sys.argv) > 3 and sys.argv[3] == '-v':
	if n <= 10:
		print('subtask 1')
	elif n <= 15:
		print('subtask 2')
	elif n <= 500:
		print('subtask 3')
	elif n <= 5000:
		print('subtask 4')
	else:
		print('subtask 5')
