const maxN = 500000 + 10;
type pairLL = record
  elem : longint;
  index : longint;
end;

type pairDP = record
  dp, ind : longint;
end;

var n, m, i, j, k, maxElem, answer, value, ind1 : longint;
    a, c : array[0 .. maxN] of longint;
    b : array[0 .. maxN] of pairLL;
    indexes : array[0 .. maxN] of array of longint;
    len, dp: array[0 .. maxN] of longint;
    pair1, pair2, temp_pair : pairDP;

procedure swap(var t, y : longint);
var u : longint;
begin
 u := t; t := y; y := u;
end;

function max(a, b : longint) : longint;
begin
 if (a > b) then max := a else max := b;
end;

function min(a, b : longint) : longint;
begin
 if (a < b) then min := a else min := b;
end;

procedure swapPair(var a, b : pairDP);
begin
 swap(a.dp, b.dp);
 swap(a.ind, b.ind);
end;


procedure sort(l, r : longint);
var i, j, x : longint;
begin
 x := b[random(r - l + 1) + l].elem;
 i := l;
 j := r;
 repeat
  while (b[i].elem < x) do i := i + 1;
  while (b[j].elem > x) do j := j - 1;
  if (i <= j) then
   begin
    swap(b[i].elem, b[j].elem);
    swap(b[i].index, b[j].index);
    i := i + 1;
    j := j - 1;
  end;
 until i > j;
 if (l < j) then sort(l, j);
 if (i < r) then sort(i, r);
end;

procedure calc(pair : pairDP; i : longint);
var ind : longint;
    ok : boolean;
begin
 if pair.dp = -MAXN then exit;
 for ind := 1 to len[i + 1] do
  begin
   ok := true;
   if (len[i] > 1) and (pair.ind + 1 = indexes[i + 1][ind]) then ok := false;
   if (ok = false) then
    begin
     dp[indexes[i + 1][ind]] := max(dp[indexes[i + 1][ind]], pair.dp + 0);
     continue;
    end;
   if (indexes[i + 1][ind] >= 2) and (a[indexes[i + 1][ind] - 1] = i) then
    dp[indexes[i + 1][ind]] := max(dp[indexes[i + 1][ind]], pair.dp + 1)
   else
    dp[indexes[i + 1][ind]] := max(dp[indexes[i + 1][ind]], pair.dp + 0);
  end;
end;

begin
 assign(input, 'sortsis.txt'); reset(input);
 assign(output, 'sortval.txt'); rewrite(output);
 readln(n);
 for i := 1 to n do read(a[i]);
 for i := 1 to n do
  b[i].elem := a[i];
 for i := 1 to n do
  b[i].index := i;
 sort(1, n);
 c[1] := 1;
 for i := 2 to n do
  if b[i].elem = b[i - 1].elem then c[i] := c[i - 1] else c[i] := c[i - 1] + 1;
 maxElem := c[n];
 for i := 1 to n do
  a[b[i].index] := c[i];
 k := 1;
 for i := 2 to n do
  if a[i] = a[k] then continue else
   begin
    k := k + 1;
    a[k] := a[i];
   end;
 n := k;
 for i := 1 to n do
  begin
   inc(len[a[i]]);
   setlength(indexes[a[i]], len[a[i]] + 1);
   indexes[a[i]][len[a[i]]] := i;
  end;
 for value := 1 to maxElem - 1 do
  begin
   pair1.dp := -MAXN;
   pair1.ind := 0;
   pair2.dp := -MAXN;
   pair2.ind := 0;
   for ind1 := 1 to len[value] do
    begin
     temp_pair.dp := dp[indexes[value][ind1]];
     temp_pair.ind := indexes[value][ind1];
     if (temp_pair.dp > pair1.dp) then
      pair1 := temp_pair;
     if (pair1.dp > pair2.dp) then swapPair(pair1, pair2);
    end;
   calc(pair1, value);
   calc(pair2, value);
  end;
 answer := maxN;
 for i := 1 to len[maxElem] do
  answer := min(answer, n - dp[indexes[maxElem][i]]);
 writeln(answer);
 close(input);
 close(output);
end.
